#!/usr/bin/perl
#
# dclinks97.pl
# Geschrieben von David S. Choi, dc@sitedeveloper.com
# 16 November 1997
#
# Ins Deutsche bersetzt von Dan Sepeur
# Mail: dan@tentacle.de
# URL: http://www.tentacle.de/tag4tag
#
##########  YOU MUST KEEP THIS COPYRIGHTS NOTICE INTACT ###############
# Copyright  1997 DCScripts All Rights Reserved
# Als einen Teil des Installationsvorganges werden Sie nach der
# Ihrer Zustimmung zu den Linzensbedingungen gebeten.
# Diese Zustimmung ist ein legaler Kontrakt, welcher die Lizensbedingungen
# zwischen Ihnen, DCScripts und DCLinks97 spezifiziert.
# Bitte stellen Sie sicher, da Sie die nachfolgende Information auf-
# merksam lesen bevor Sie die Software installieren und benutzen.
# Esseidenn, Sie haben eine andere, von dieser hier abweichende
# Lizensbestimmung von DCScripts.
# Wenn Sie den Lizensbedingungen nicht zustimmen, stellen Sie sicher
# da Sie alle Kopien und Programmteile dieser Software von Ihrem
# Computer lschen.
#
# Versionen dieser Software 
# Sie knnen so viele Versionen von DCLinks97 installieren, wie Sie
# mchten.
# 
# Vereinbarung zum Weiterverkauf
# Die Distribution dieser Software und/oder der Dokumentation mit
# anderen Produkten (kommerziell oder andersartig) oder durch andere
# elektronische Vertreitungsmittel ohne die ausdrckliche schriftliche
# Genehmigung von DCSripts nicht erlaubt.
# Alle Rechte an DCLinks97 und den Dokumentationen garantieren nicht
# den einwandfreien Betrieb von DCLinks97, stehen aber unter den
# Lizensvereinbarungen von DCScripts.
#
# 
# Garantiebestimmungen
# DIESE SOFTWARE UND DIE MITGELIEFERTE DOKUMENTATION WIRD SO VERTRIEBEN
# WIE SIE ERSTELLT WURDE. UND DAS OHNE DEN ANSPRUCH AUF VOLLSTNDIGKEIT
# UND OHNE DIE GARANTIE AUF GESCHWINDIGKEIT UND LAUFFHIGKEIT IN JEDEM
# FALL, DA JEDER RECHNER SICH VON DEM ANDEREN UNTERSCHEIDET UND SOMIT
# IMMER ANDERS KONFIGURIERT IST. DER USER MUSS DIESEN VEREINBARUNGEN
# ZUSTIMMEN UND GIBT AN DIE SOFTWARE AUF SEIN EIGENES RISIKO ZU NUTZEN.
# HKDESIGN BERNIMMT KEINERLEI HAFTUNG FR FEHLERHAFTE BEDIENUNG UND
# DARAUS RESULTIERENDEN FEHLERN AN HARD- ODER SOFTWARE.
#
###########################################################################

# Hier bitte den Pfad zu der Setup-Datei angeben
# Versuchen Sie bitte einmal den relativen Pfad anzugeben.

$path = ".";

#----Sie brauchen diese Zeile nicht zu ndern, wenn das Script
#    so luft

require "$path/dclinks98.setup";
require "$cgidir/cgi-lib.pl";

# OK, wir lesen hier die Formulardaten ein

&ReadParse;

# Den HTTP-Header Senden

print "Content-type: text/html\n\n";

# Formatiere den Kommentar-Input damit er richtig in die
# Datenbank eingepflegt werden kann

if ($in{'Beschreibung'}) {
	$in{'Beschreibung'} =~ s/</&lt;/g;
	$in{'Beschreibung'} =~ s/>/&gt;/g;
	$in{'Beschreibung'} =~ s/\cM//g;
	$in{'Beschreibung'} =~ s/\n\n/ /g;
	$in{'Beschreibung'} =~ s/\n/ /g;
}


# Sortiere Formular-Input:
#	1) Anzeigen der Hinzugefgten Links im Linkformular
#	2) Hinzufgen der Link-Information in die Datenbank
# 	3) Links anzeigen

if ($in{'action'} eq "add_form") {

	$header = $add_links_header;
	$sub_header = $add_links_sub_header;

	&add_form;
}
elsif ($in{'action'} eq "add_links") {

	$header = $thank_you_header;
	$sub_header = $thank_you_sub_header;

	&add_links;

	$header = $display_main_header;
	$sub_header = $display_main_sub_header;

	&display_main;

}
elsif ($in{'action'} eq "view_category") {

	$header = $display_view_header;
	$sub_header = $display_view_sub_header;
	
	&view_category;
}
else {

	$header = $display_main_header;
	$sub_header = $display_main_sub_header;

	&display_main;
}

&display_output;

exit(0);

####################### ENDE DES GRUNDPROGRAMMES ####################

sub display_main {

	open(LINKSDATA,"$datafile") || die $!;
	flock(LINKSDATA,2);
		@linksdata = <LINKSDATA>;
	flock(LINKSDATA,8);
	close(LINKSDATA);

	foreach $line (@linksdata)
	{
		(@linedata) = split(/\|/,$line);
		$Kategorie_num{$linedata[$cat_id]}++;
	}

	$html_output .= "<ul>\n";
	foreach $cat (@Kategorie_list)
	{
		$cat1 = $cat;
		$cat =~ tr/ /+/;

		if ($Kategorie_num{"$cat1"} eq "" ) {$Kategorie_num{"$cat1"} = "0";}
	
		$html_output .= qq~
		<li>
		<b>
		<a href="$dcscript?action=view_category&category=$cat">$cat1</a>
		</b>
		($Kategorie_num{"$cat1"} links)
		<br>
		 $Kategorie_desc{$cat1}
		<P>
		</li>~;
	}
	$html_output .= "</ul>\n";
}


sub view_category {

	$category = $in{"category"};
	
	$category =~ tr/+/ /;
	
	open(LINKSDATA,"$datafile") || die $!;
	flock(LINKSDATA,2);
		@linksdata = <LINKSDATA>;
	flock(LINKSDATA,8);
	close(LINKSDATA);

	$html_output .= qq~
	<P align="center">
	<B>Gesichtete Links in $category</b>
	<P align="center">
	~;
	
	foreach $line (@linksdata)
	{
		@row = split(/\|/,$line);

		foreach ($j = 0;$j <= @row-1;$j++)
		{
			$rowdata{$link_fields[$j]} = $row[$j];
		}
		
		if ($rowdata{$link_fields[$cat_id]} =~ /$category/)
		{
			$html_output .= qq~
			<li>~;
			$html_output .= &list_record(@rowdata);
			$html_output .= qq~
			</li>
			~;			
		
		}


	}

}


sub list_record {

	local(@rowdata) = @_;
	local($output);
	
	$rowdata{"Homepage"} =~ s/http:\/\///g;
	$output .= qq~
	<a href="http://$rowdata{"Homepage"}">$rowdata{"Name"}</a>
	$rowdata{"Beschreibung"}
	~;
	
	$output;
}

sub add_links {

	open(LINKSDATA,"$datafile") || die $!;
	flock(LINKSDATA,2);
		@linksdata = <LINKSDATA>;
	flock(LINKSDATA,8);
	close(LINKSDATA);

	foreach (@linksdata) {
		if ($_ =~ /$in{'Homepage'}/) {
			$header = "ERROR!!! Doppelter Link!";
			$sub_header = "Sind Sie sicher, da Sie die korrekte URL angegeben haben?";
			$html_output .= qq~
				Unsere Linkdatenbank beinhaltet Ihren Link schon...
			~;
			&display_output;
			exit(0);
		}
	}
	
	$id = &get_number();
	($date,$localtime) = &get_date();
	$date = $localtime." ".$date;

	$in{'ID'} = $id;
	$in{'Date'} = $date;

	foreach $field (@link_fields)
	{
		$in{$field} =~ s/\|/\s/g;
		$newline .= $in{$field}."|";
	}

	chop($newline);
	$newline .= "\n";
	
	open(LINKSDATA,">$datafile") || die $!;
	flock(LINKSDATA,2);
		print LINKSDATA $newline;
		print LINKSDATA @linksdata;
	flock(LINKSDATA,8);
	close(LINKSDATA);
	
}

sub add_form {

	
	$html_output .= qq~
	<center>
	<table border="0">
	<form action="$dcscript" method="post">
	<input type="hidden" name="action" value="add_links">~;
	
	foreach $link_field (@link_fields)
	{
		$html_output .= &table_row($link_field,$field_input_type{$link_field});
	}
	$html_output .= qq~
	<tr>
	<td colspan="2" align="center">
	<input type="submit" value="Meinen Link hinzufgen!">
	<input type="reset">
	</form>
	</table>
	</center>~;
}

sub table_row {

	local($field,$type);
	($field,$type) = @_;
	local($table_row);
	
	if ($type eq "text")
	{
		$table_row .= qq~
		<tr>
		<td valign="top">
		$field
		</td>
		<td>
		<input type="$type" name="$field" size="40">
		</td>
		</tr>
		~;
	}
	elsif ($type eq "textarea")
	{
		$table_row .= qq~
		<tr>
		<td valign="top">
		$field
		</td>
		<td>
		<textarea name="$field" rows="6" cols="40" wrap="physical"></textarea>
		</td>
		</tr>
		~;
		
	}
	elsif ($type eq "select")
	{
		@option_list = eval("@".$field."_list");
		$table_row .= qq~
		<tr>
		<td valign="top">
		$field
		</td>
		<td>
		<select name="$field">~;
		foreach $option (@option_list)
		{
			$table_row .= "<option value=\"$option\">$option\n";
		}
		
		$table_row .= qq~
		</select>
		</td>
		</tr>
		~;

	}
	
	$table_row;
}

sub get_number {
	
	local($num);
		
	open(NUMBER,"$counter") || die $!;
   		$num = <NUMBER>;
	close(NUMBER);

	$num++;

	open(NUMBER,">$counter") || die $!;
   		print NUMBER $num;
	close(NUMBER);
	 	  
	$num;
}

sub display_output {

	open(TEMPLATE,"$booktemplate") || die $!;
		while (<TEMPLATE>)
		{
			$template .= $_;
		}
	close(TEMPLATE);
	$template =~ s/\$HTML_OUTPUT/$html_output/g;
	$template =~ s/\$HEADER/$header/g;
	$template =~ s/\$SUB_HEADER/$sub_header/g;
	print $template;

}

sub get_date {

   local($date,$localtime);
   
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

   if ($sec < 10) {
      $sec = "0$sec";
   }
   if ($min < 10) {
      $min = "0$min";
   }
   if ($hour < 10) {
      $hour = "0$hour";
   }
   if ($mon < 10) {
      $mon = "0$mon";
   }
   if ($mday < 10) {
      $mday = "0$mday";
   }

   $month = ($mon + 1);

   @months = ("Januar","Februar","Maerz","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember");

   $localtime = "$hour\:$min\:$sec";
   $date = "$mday/$month/$year";
   chop($date) if ($date =~ /\n$/);
   chop($local) if ($local =~ /\n$/);

   ($date,$localtime);
   
}
